/*
 * txt.cpp
 *
 *  Created on: 26.01.2012
 *      Author: rnasucin
 */
#include "txt.h"
#include <string>
#include <fstream>
#include <iostream>
#include <sys/types.h>
#include <dirent.h>
#include <list>
#include <stdio.h>

using namespace std;

textdatei::textdatei(string my_appname) {
	set_App_path(my_appname);
	cout << my_appname << endl;
}

void textdatei::set_App_path (string appname) {
	// 												DONT TEST THIS APP ON YOUR HDA!
	// string HDAdocroot = "/var/hda/web-apps/";
	// UNCOMMENT ABOVE STRING AND USE THIS ONE:
	string HDAdocroot = "/tmp/hdadocroot/";
	// Dont use HDAdocroot = "/var/hda/web-apps/" !
	// until this program gets released!
	string htmlfolder = "/html/";
	string Path = "";
	Path = HDAdocroot;
	Path += appname;
	Path += htmlfolder;
	App_path = Path;
}
string textdatei::get_App_path () {
	return App_path;
}

string textdatei::ReadFirstLine(string sFilename) {
	string sContent = "";
	ifstream File;
	File.open(sFilename.c_str(), ios::out|ios::app);
	if (File.is_open())
	{
//		File >> sContent;
		getline(File,sContent);
		File.close();
	} else {
		bool flag = 0;
		throw flag;
	}
	return sContent;
}
bool textdatei::AmahiFlag(string sFilename) {
	string tmp = ReadFirstLine(sFilename);
	if (tmp == "// HDA") {
		return true;
	} else {
		return false;
	}
}
string textdatei::get_main_file () {
	string read_App_path = App_path;
	list<string> files;
    DIR *dp;
    struct dirent *dirp;
    if((dp  = opendir(read_App_path.c_str())) == NULL) {
        throw read_App_path;
    }
    while ((dirp = readdir(dp)) != NULL) {
        files.push_back(string(dirp->d_name));
//    	cout << (string(dirp->d_name)) << endl;
    }
    closedir(dp);
//	cout << (int) files.size() << endl;
    list<string>::iterator i;
    for (i = files.begin(); i != files.end(); i++)
//    	cout << *i << endl;
    	if (*i == "index.php") {
    		my_filetype = PHP;
    		return (read_App_path + "index.php");
    	} else if (*i == "index.html") {
    		my_filetype = HTML;
    		return (read_App_path + "index.html");
    	}
    throw read_App_path;
}

void textdatei::set_index (bool i_flag) {
	ofstream File_of;
	ifstream File_if;
	ofstream buffer_of;
	ifstream buffer_if;
	string buffer_str;
	string mainfile = get_main_file();
	File_if.open(mainfile.c_str(), ios::in|ios::app);
	buffer_of.open("/tmp/piwik_mon", ios::out|ios::app);
	while( getline(File_if, buffer_str) )
	{
	    buffer_of << buffer_str << endl;
	}
	File_if.close();
	buffer_of.close();
	File_of.open(mainfile.c_str(), ios::out);
	buffer_if.open("/tmp/piwik_mon", ios::in|ios::app);
	File_of << "// HDA" << endl;
	if (my_filetype == PHP) {
		ofstream piwik_tracker_php;
		ifstream piwik_tracker_php_tmp;
		string piwik_tracker_path;
		piwik_tracker_path = App_path;
		piwik_tracker_path += "PiwikTracker.php";
		piwik_tracker_php.open(piwik_tracker_path.c_str(), ios::out);
		piwik_tracker_php_tmp.open("/tmp/PiwikTracker.php", ios::in);
		while (getline(piwik_tracker_php_tmp, buffer_str)) {
			piwik_tracker_php << buffer_str << endl;
		}
		piwik_tracker_php.close();
		piwik_tracker_php_tmp.close();
		File_of << "<?php" << endl;
		File_of << "// -- Piwik Tracking API init --" << endl;
		File_of << "require_once \"" << piwik_tracker_path << "\";" << endl;
		File_of << "PiwikTracker::$URL = 'http://demo.piwik.org/';" << endl;
		// Method 1: Advanced Image Tracker
		// Tracking Code Example 1
		File_of << "// Example 1: Tracks a pageview for Website id = {$IDSITE}" << endl;
		File_of << "echo '<img src=\"'. str_replace(\"&\",\"&amp;\", Piwik_getUrlTrackPageView( $idSite = {$IDSITE}, $customTitle = 'This title will appear in the report Actions > Page titles')) . '\" alt=\"\" />';" << endl;
		File_of << "?>" << endl;
	} else if (my_filetype == HTML) {
		ofstream piwik_tracker_php;
		ifstream piwik_tracker_php_tmp;
		string piwik_tracker_path;
		piwik_tracker_path = App_path;
		piwik_tracker_path += "PiwikTracker.php";
		piwik_tracker_php.open(piwik_tracker_path.c_str(), ios::out);
		piwik_tracker_php_tmp.open("/tmp/PiwikTracker.php", ios::in);
		while (getline(piwik_tracker_php_tmp, buffer_str)) {
			piwik_tracker_php << buffer_str << endl;
		}
		piwik_tracker_php.close();
		piwik_tracker_php_tmp.close();
		File_of << "<?php" << endl;
		File_of << "// -- Piwik Tracking API init --" << endl;
		File_of << "require_once \"" << piwik_tracker_path << "\";" << endl;
		File_of << "PiwikTracker::$URL = 'http://demo.piwik.org/';" << endl;
		// Method 2: HTTP Request
		File_of << "?php" << endl;
		File_of << "$piwikTracker = new PiwikTracker( $idSite = {$IDSITE} );" << endl;
		File_of << "// You can manually set the visitor details (resolution, time, plugins, etc.)" << endl;
		File_of << "// See all other ->set* functions available in the PiwikTracker.php file" << endl;
		File_of << "$piwikTracker->setResolution(1600, 1400);" << endl;
		File_of << "// Sends Tracker request via http" << endl;
		File_of << "$piwikTracker->doTrackPageView('Document title of current page view');" << endl;
		File_of << "// You can also track Goal conversions" << endl;
		File_of << "$piwikTracker->doTrackGoal($idGoal = 1, $revenue = 42);" << endl;
		File_of << "?>" << endl;
	} else {
		throw mainfile;
	}

	while (getline(buffer_if, buffer_str)) {
		File_of << buffer_str << endl;
	}
	File_of.close();
	buffer_if.close();
	if( remove( "/tmp/piwik_mon" ) != 0 )
		perror( "Error deleting file" );
}
